//+------------------------------------------------------------------+
//|                                                               XO |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  Gold
#property indicator_color4  Gray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  3
#property indicator_width4  3
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern string ForSymbol        = "";
extern double BoxSize1         =  6.5;
extern double BoxSize2         = 30.0;
extern string arrowsIdentifier = "XOarrows";
extern bool   ShowArrows1      = false;
extern color  arrowsUpColor1   = DeepSkyBlue;
extern color  arrowsDnColor1   = PaleVioletRed;
extern bool   ShowArrows2      = false;
extern color  arrowsUpColor2   = Gold;
extern color  arrowsDnColor2   = Gray;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double no1[];
double kr1[];
double no2[];
double kr2[];
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);   
      SetIndexBuffer(0,kr1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,no1); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,kr2);
      SetIndexBuffer(3,no2);
      SetIndexBuffer(4,trend1);
      SetIndexBuffer(5,trend2);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
            if (StringTrimLeft(StringTrimRight(ForSymbol))=="") ForSymbol=Symbol();

      //
      //
      //
      //
      //
      
   IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" XO ("+DoubleToStr(BoxSize1,2)+","+DoubleToStr(BoxSize2,2)+")");
   return(0);
}
int deinit()
{
   if (!calculateValue && (ShowArrows1 || ShowArrows2)) deleteArrows();
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];
#define _hi1 0
#define _lo1 1
#define _hi2 2
#define _lo2 3

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { kr1[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
    
   if (calculateValue || (ForSymbol==Symbol() && timeFrame == Period()))
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         double pipModifier = 1; 
            if (Digits==3 || Digits==5) pipModifier=10;
      
      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {         
         double cur = Close[i];
         if (i>=(Bars-2))
            {
               work[r][_hi1]=cur; work[r][_hi2]=cur;
               work[r][_lo1]=cur; work[r][_lo2]=cur;
               continue; 
            }

         //
         //
         //
         //
         //
      
            work[r][_hi1] = work[r-1][_hi1];
            work[r][_lo1] = work[r-1][_lo1];
            work[r][_hi2] = work[r-1][_hi2];
            work[r][_lo2] = work[r-1][_lo2];
            no1[i]        = no1[i+1];
            kr1[i]        = kr1[i+1];
            no2[i]        = no2[i+1];
            kr2[i]        = kr2[i+1];
            trend1[i]     = trend1[i+1];
            trend2[i]     = trend2[i+1];

            if (cur > (work[r][_hi1]+BoxSize1*pipModifier*Point)) { work[r][_hi1] = cur; work[r][_lo1] = cur-BoxSize1*pipModifier*Point; kr1[i] += 1; no1[i] = 0; }
            if (cur < (work[r][_lo1]-BoxSize1*pipModifier*Point)) { work[r][_lo1] = cur; work[r][_hi1] = cur+BoxSize1*pipModifier*Point; no1[i] -= 1; kr1[i] = 0; }
            if (cur > (work[r][_hi2]+BoxSize2*pipModifier*Point)) { work[r][_hi2] = cur; work[r][_lo2] = cur-BoxSize2*pipModifier*Point; kr2[i] += 1; no2[i] = 0; }
            if (cur < (work[r][_lo2]-BoxSize2*pipModifier*Point)) { work[r][_lo2] = cur; work[r][_hi2] = cur+BoxSize2*pipModifier*Point; no2[i] -= 1; kr2[i] = 0; }
               if (kr1[i] > 0) trend1[i]= 1;
               if (no1[i] < 0) trend1[i]=-1;
               if (kr2[i] > 0) trend2[i]= 1;
               if (no2[i] < 0) trend2[i]=-1;
            manageArrow(i);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars","",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
         kr1[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,0,y);
         no1[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,1,y);
         kr2[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,2,y);
         no2[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,3,y);
         trend1[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,4,y);
         trend2[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"CalculateValue","",BoxSize1,BoxSize2,5,y);
         manageArrow(i);
   }
   manageAlerts();
   return(0);         
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static string   mess1="";
      static string   mess2="";
      static datetime time1=0;
      static datetime time2=0;
         if (trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] == 1) doAlert(mess1,time1,whichBar,"primary changed to up");
            if (trend1[whichBar] ==-1) doAlert(mess1,time1,whichBar,"primary changed to down");
         }         
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] == 1) doAlert(mess2,time2,whichBar,"secondary changed to up");
            if (trend2[whichBar] ==-1) doAlert(mess2,time2,whichBar,"secondary changed to down");
         }         
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(ForSymbol+" "+timeFrameToString(timeFrame)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," XO ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"XO "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ForSymbol==Symbol())
   {
      if (ShowArrows1)
      {
         deleteArrow("p",Time[i]);
         if (trend1[i]!=trend1[i+1])
         {
            if (trend1[i] == 1) drawArrow("p",i,arrowsUpColor1,139,false);
            if (trend1[i] ==-1) drawArrow("p",i,arrowsDnColor1,139,true);
         }
      }         
      if (ShowArrows2)
      {
         deleteArrow("s",Time[i]);
         if (trend2[i]!=trend2[i+1])
         {
            if (trend2[i] == 1) drawArrow("s",i,arrowsUpColor2,139,false,3);
            if (trend2[i] ==-1) drawArrow("s",i,arrowsDnColor2,139,true ,3);
         }
      }         
   }
}               

//
//
//
//
//

void drawArrow(string add, int i,color theColor,int theCode,bool up, double gapMul=1)
{
   string name = arrowsIdentifier+":"+add+Time[i];
   double gap  = gapMul*3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(string add, datetime time)
{
   string lookFor = arrowsIdentifier+":"+add+time; ObjectDelete(lookFor);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}